%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% (c) Hossam A.  H.  Fahmy 
%
%    This work may be distributed and/or modified under the
%    conditions of the LaTeX Project Public License, either version 1.3
%    of this license or (at your option) any later version.
%    The latest version of this license is in
%      http://www.latex-project.org/lppl.txt
%    and version 1.3 or later is part of all distributions of LaTeX
%    version 2005/12/01 or later.
% 
% This work has the LPPL maintenance status `maintained'.
%
% The Current Maintainer of this work is Hossam A. H. Fahmy.
% (hfahmy@arith.stanford.edu)
%
% This work consists of all the files listed in alqalam_manifest.txt.
%
% Based on the original work of the arabtex package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 21 Ramadan 1428, 3 Oct 2007
%%%%%%%%%%%%%%%%%%%%%%%% qasura.sty %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% 
%  Comments from Pradipta:
%
%
%
% This package is used to provide a sura and ayat environment in the quran
% Here we use temp variable since we can't use "\advance \global\ayatCount by 1"
% so instead of using advance directly, we use temp variable
% (because we can't change the variable inside the group directly)
% problem found : 
% 1. I dont know about arabic numbering in textual form, so i just simply use the number.
% 2. There is a possibility that i make a mistake in the name of sura, although i have checked it before.
%	Beside, a sura may have have more than one name.
% 3. We cant use \if command in arab environment,
%	Solution: we add \end{RLtext} and in the end of newcommand, we add \begin{RLtext}
%	However, it may cause a new problem, because it will print the new line for \ayat command, so in \ayat command, 
%	I use \LR instead of \begin{RLtext}
% 4.  Please take note in the number of ayat. It may be different\wrong.

% source for name of sura & no. of ayat
% http://www.yildun.com/data/quran/english/sura8.html
% http://i-cias.com/e.o/koran.htm

% parameter for "sura" command:
% 1  Sura number
% 2  Sura name
% 3  Makkiyah or madaniyat
% 4. Ayat number

%====================================================
%Revision May-June2006:
%1. Add the parameter
%2. I use the parameter in Latin Letter
%3. For parameter Makkiyah or madaniyat, I use latin word instead of number(i.e. 1 for makkiyat and 2 for madaniyat)
%	so, it is possible for future development: because in one sura, it is possible that some part in ayat are makiyat
%	and the other parts is madaniyat
%4. I make the parameter flexible (user can specify one parameter only).
%	However, we can set more strict condition
%5. We can not do error checking(for ayat number) in the last sura, unless we use \suraEnd command
%6. In this code, I can not use optional parameter, I do not know why,
%	So, i have to use \ifthenelse to solve the problem
%	Another thing: in latin environment, the comparison should be \ifthenelse{\equal{#3}{\newline}}
%7. We try to make table of contents macro by using "index", but it seems that it is not practical
%	Later, we know that arabtex support \tableofcontents as long as we use certain classes: 
%	arabart, arabrep, arabbook. But it is not enough. We still need to modify the code by adding:
%	\addcontentsline
%8. Change from \fbox to \framebox, so that it can be used in arabart, arabrep, arabbook class
%9. We use \parbox so that we can set the width for sura Name, sura No,
%10.To make table of contents, we can either use \makeindex or use \tableofcontents depend on the class
%	Note:
%		 - If you use \makeindex you also have to run java class "arabIndex" and then put : \input nameFile.txt
%		on the tex source 
%11.I wish I know how to store "string" variable in latex. 
%	If I can, i can make the page header display number of juz
%

%To do:
%1. combine this package with rub / Harabmargin so that it can display juz number in the header of the page

% Bug Found:
% 1. 
%====================================================

\ProvidesPackage{qasura}[2006/05/28 1.0]

\usepackage{ifthen}%

\newcount \suraNo
\newcount \ayatNo
\newcount \ayatCount
\newcount \temp % temporary variable
\newcount \tempBool % temporary variable to indicate first sura or not

%these settings are used for page numbering support
\setcounter{page}{1}
\allowarab{\thepage}
\allowarab{\csname}
\allowarab{\@arabic}
\allowarab{\number}

\suraNo=0
\tempBool=0


\newlength{\cwidth}
\setlength{\cwidth}{.36\columnwidth}


% It would be better if we can convert ayat No to text
% But, I dont know how to spell it
% I use parbox, so that we can set the width for each part in sura environment.
\newcommand{\header}[2]{%
	\transfalse%
	%
	%\pageheader{}{\thepage}{#1}%
	%\pagefooter{}{}{}%
    \hfill\newline%to solve the badness in the first sura box
	\fboxrule=2pt
	\framebox[\the\columnwidth]{%
		\ifdim\columnwidth>210pt%
		\parbox{0.15\columnwidth}{%
			\begin{RLtext}%display ayat Number
			\n{\hfill\the\ayatNo\hfill\RL{ءَايَـة}\hfill}% to allow numbers to appear
			\end{RLtext}%
		}\fi\ifdim\columnwidth>380pt\parbox{0.15\columnwidth}{%
		\hfill\lfig\hfill
		}\else\ifdim\columnwidth>340pt\parbox{0.12\columnwidth}{%
		\hfill\sfig\hfill
		}\else\ifdim\columnwidth>210pt\parbox{0.12\columnwidth}{%
		\hfill\mfig\hfill
		}\fi\fi\fi\LR\parbox{\cwidth}{%
			\begin{RLtext}%
			\hfill\RL{ سُـورَةُ #1 }\hfill%
			\end{RLtext}%
			%
		}\ifdim\columnwidth>380pt\parbox{0.15\columnwidth}{%
		\hfill\lfig\hfill
		}\else\ifdim\columnwidth>340pt\parbox{0.12\columnwidth}{%
		\hfill\sfig\hfill
		}\else\ifdim\columnwidth>210pt\parbox{0.12\columnwidth}{%
		\hfill\mfig\hfill
		}\fi\fi\fi%
		\LR\ifdim\columnwidth>210pt\parbox{0.15\columnwidth}{%
			\begin{RLtext}%
			\hfill #2\hfill%
			\end{RLtext}
		}\fi%
	}%
}%


\gdef \lfig{%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}}
\gdef \sfig{%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}}
	
\gdef \mfig{%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}%
	\kern-1em{\rotatebox{-90}{\RL{\char'332}}}}
	

	
	


%\newcommand{\headerOther}[2]{%
%	\hfill\newline%to solve the badness in the first sura box
%	\framebox[\the\columnwidth]{%
%		%
%		\parbox{0.4\columnwidth}{%
%			\begin{RLtext}%
%			\hfill\the\ayatNo\RL{ْءَايَـة}\hfill%
%			\end{RLtext}%
%			%
%		}\LR{\vline\@width 2pt}\parbox{0.6\columnwidth}{%
%			\begin{RLtext}%
%			\hfill \RL{سُورَةُ}#1 #2\hfill%
%			\end{RLtext}
%		}%
%	}%
%}%

\newcommand{\getTable}[1]{%
\index{#1}\addcontentsline{toc}{section}{\protect\numberline{\the\suraNo}#1}%
}%

\newcommand{\headerCondition}[2]{%
%\ifnum\suraNo=9%
%\headerOther{#1}{#2}%
%\else%
\header{#1}{#2}%
%\fi%
}%

\newcommand{\getHeader}[4]{%
\ifthenelse{\equal{#1}{} \and \equal{#2}{}}%no ayat Name and no  makiyat or madaniyat parameter
{\headerCondition{#3}{#4}%
\getTable{#3}}{}%
\ifthenelse{\equal{#1}{} \and \not\(\equal{#2}{}\)}%no ayat Name but there is makiyat or madaniyat parameter
{\headerCondition{#3}{#2}%
\getTable{#3}}{}%
\ifthenelse{\not\(\equal{#1}{}\) \and \equal{#2}{}}%we got ayat Name but no makiyat or madaniyat parameter
{\headerCondition{#1}{#4}%
\getTable{#1}}{}%
\ifthenelse{\not\(\equal{#1}{}\) \and \not\(\equal{#2}{}\)}%we got ayat Name and makiyat and madaniyat parameter
{\headerCondition{#1}{#2}%
\getTable{#1}}{}%
}%

\allowarab{\the}
\allowarab{\header}
\allowarab{\headerOther}

\newcommand{\sura}[4]{%
\end{RLtext}% to enable \ifcommand, we must go to normal latex
%
%\transfalse% this command can be removed
%\novocalize% this command can be removed
%
% check if number of ayat is less
\ifnum\tempBool=0% no error checking for first sura
\tempBool=1%
\else%
\ifnum\value{ayac}<\ayatNo%
\PackageError{lessAyat}{The number of ayat = \the\ayatCount \ for sura = \the\suraNo.%
It should be \the\ayatNo. Pls correct it.}%
{use more ayat}%
\else%
%sura \the\suraNo and ayatCount = \the\ayatCount and ayatNo = \the\ayatNo%error checking
\fi% end of ifnum
\fi% end of ifnum
%
\ifthenelse{\equal{#1}{}}{\advance \suraNo by 1}{\suraNo=#1}%
\setcounter{ayac}{0}
%\ayatCount=0%
%
% check if there are more than 114 sura
\ifnum\suraNo>114%
\PackageError{suraExceeded}{The number of sura more than 114. Pls correct it.}%
{use less sura}%
\else%
\fi% end of ifnum
% number of ayat in every sura
\ifthenelse{\equal{#4}{}}{% \or \equal{#1}{}}{%check ayatNo parameter
\ifcase\suraNo%
\or{\global\ayatNo=7}%
\or{\global\ayatNo=286}%
\or{\global\ayatNo=200}%
\or{\global\ayatNo=175}%
\or{\global\ayatNo=120}%
\or{\global\ayatNo=165}%
\or{\global\ayatNo=205}%
\or{\global\ayatNo=76}%
\or{\global\ayatNo=130}%
\or{\global\ayatNo=109}%
\or{\global\ayatNo=123}%
\or{\global\ayatNo=111}%
\or{\global\ayatNo=43}%
\or{\global\ayatNo=52}%
\or{\global\ayatNo=99}%
\or{\global\ayatNo=128}%
\or{\global\ayatNo=111}%
\or{\global\ayatNo=110}%
\or{\global\ayatNo=98}%
\or{\global\ayatNo=135}%
\or{\global\ayatNo=112}%
\or{\global\ayatNo=78}%
\or{\global\ayatNo=118}%
\or{\global\ayatNo=64}%
\or{\global\ayatNo=77}%
\or{\global\ayatNo=227}%
\or{\global\ayatNo=95}%
\or{\global\ayatNo=88}%
\or{\global\ayatNo=69}%
\or{\global\ayatNo=60}%
\or{\global\ayatNo=34}%
\or{\global\ayatNo=30}%
\or{\global\ayatNo=73}%
\or{\global\ayatNo=54}%
\or{\global\ayatNo=45}%
\or{\global\ayatNo=83}%
\or{\global\ayatNo=182}%
\or{\global\ayatNo=88}%
\or{\global\ayatNo=75}%
\or{\global\ayatNo=85}%
\or{\global\ayatNo=54}%
\or{\global\ayatNo=53}%
\or{\global\ayatNo=89}%
\or{\global\ayatNo=59}%
\or{\global\ayatNo=36}%
\or{\global\ayatNo=34}%
\or{\global\ayatNo=40}%
\or{\global\ayatNo=29}%
\or{\global\ayatNo=17}%
\or{\global\ayatNo=45}%
\or{\global\ayatNo=60}%
\or{\global\ayatNo=49}%
\or{\global\ayatNo=62}%
\or{\global\ayatNo=55}%
\or{\global\ayatNo=78}%
\or{\global\ayatNo=96}%
\or{\global\ayatNo=29}%
\or{\global\ayatNo=22}%
\or{\global\ayatNo=24}%
\or{\global\ayatNo=13}%
\or{\global\ayatNo=14}%
\or{\global\ayatNo=11}%
\or{\global\ayatNo=11}%
\or{\global\ayatNo=18}%
\or{\global\ayatNo=12}%
\or{\global\ayatNo=12}%
\or{\global\ayatNo=30}%
\or{\global\ayatNo=52}%
\or{\global\ayatNo=52}%
\or{\global\ayatNo=44}%
\or{\global\ayatNo=29}%
\or{\global\ayatNo=28}%
\or{\global\ayatNo=20}%
\or{\global\ayatNo=55}%
\or{\global\ayatNo=39}%
\or{\global\ayatNo=31}%
\or{\global\ayatNo=50}%
\or{\global\ayatNo=41}%
\or{\global\ayatNo=45}%
\or{\global\ayatNo=42}%
\or{\global\ayatNo=29}%
\or{\global\ayatNo=19}%
\or{\global\ayatNo=36}%
\or{\global\ayatNo=25}%
\or{\global\ayatNo=22}%
\or{\global\ayatNo=17}%
\or{\global\ayatNo=19}%
\or{\global\ayatNo=26}%
\or{\global\ayatNo=30}%
\or{\global\ayatNo=20}%
\or{\global\ayatNo=15}%
\or{\global\ayatNo=21}%
\or{\global\ayatNo=11}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=19}%
\or{\global\ayatNo=5}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=11}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=8}%
\or{\global\ayatNo=3}%
\or{\global\ayatNo=9}%
\or{\global\ayatNo=5}%
\or{\global\ayatNo=4}%
\or{\global\ayatNo=7}%
\or{\global\ayatNo=3}%
\or{\global\ayatNo=6}%
\or{\global\ayatNo=3}%
\or{\global\ayatNo=5}%
\or{\global\ayatNo=4}%
\or{\global\ayatNo=5}%
\or{\global\ayatNo=6}%
\fi% end of ifcase
}{\global\ayatNo=#4}%
%
%مَكيَّة
%مَدَنيَّـة
\ifcase\suraNo% 
\or \getHeader{#2}{#3}{الفَاتِحَةِ}َ{مَكيَّة}% Al Fatihah
\or \getHeader{#2}{#3}{البَقَـرَةِ}{مَدَنيَّـة}% Al Baqarah
\or \getHeader{#2}{#3}{آلِ عِمرَانَ}{مَدَنيَّـة}% Al Imran
\or \getHeader{#2}{#3}{النِّساءِ}{مَدَنيَّـة}% An Nisa
\or \getHeader{#2}{#3}{المَــائِدَةِ}{مَدَنيَّـة}% Al Maida
\or \getHeader{#2}{#3}{الأنعَـامِ}{مَكيَّة}% Al Anam
\or \getHeader{#2}{#3}{الأعـرَافِ}{مَكيَّة}% Al Araf
\or \getHeader{#2}{#3}{الأنفَـالِ}{مَدَنيَّـة}% Al Anfal
\or \getHeader{#2}{#3}{التَّوْبَةِ}{مَدَنيَّـة}% Al Tauba
\or \getHeader{#2}{#3}{يُونسَ}{مَكيَّة}% Yunus
\or \getHeader{#2}{#3}{هُودٍ}{مَكيَّة}% Hood
\or \getHeader{#2}{#3}{يُوسُفَ}{مَكيَّة}% Yusuf
\or \getHeader{#2}{#3}{الرَّعْـدِ}{مَدَنيَّـة}% Ar Ra'd
\or \getHeader{#2}{#3}{إِبراهِيمَ}{مَكيَّة}% Ibrahim
\or \getHeader{#2}{#3}{الحِـجْرِ}{مَكيَّة}% Al Hijr
\or \getHeader{#2}{#3}{النَّحْلِ}{مَكيَّة}% An Nahl
\or \getHeader{#2}{#3}{الإِسْرَاءِ}{مَكيَّة}% Al Isra %dipta wrote it as {baniy isra-a'iyl} 
\or \getHeader{#2}{#3}{الكَهْفِ}{مَكيَّة}% Al  Kahf
\or \getHeader{#2}{#3}{مَريَمَ}{مَكيَّة}% Maryam
\or \getHeader{#2}{#3}{طَـه}{مَكيَّة}% Taahaa
\or \getHeader{#2}{#3}{الأَنبيَاءِ}{مَكيَّة}% Al Anbiya
\or \getHeader{#2}{#3}{الـحَجِ}{مَدَنيَّـة}% Al Hajj
\or \getHeader{#2}{#3}{المُؤمنُونَ}{مَكيَّة}% Al Mu'minun
\or \getHeader{#2}{#3}{النُّورِ}{مَدَنيَّـة}% An Noor
\or \getHeader{#2}{#3}{الفُرقَانِ}{مَكيَّة}% Al Furqan
\or \getHeader{#2}{#3}{الشُعَرَاءِ}{مَكيَّة}% Ash Shuara
\or \getHeader{#2}{#3}{النَّملِ}{مَكيَّة}% An Naml
\or \getHeader{#2}{#3}{القَصَصِ}{مَكيَّة}% Al Qasas
\or \getHeader{#2}{#3}{العَنكَبُوتِ}{مَكيَّة}% Al Ankabut
\or \getHeader{#2}{#3}{الرُومِ}{مَكيَّة}% Ar Rom
\or \getHeader{#2}{#3}{لُقمَانَ}{مَكيَّة}% Lokman
\or \getHeader{#2}{#3}{السَّجدَةِ}{مَكيَّة}% As Sajda
\or \getHeader{#2}{#3}{الأَحزابِ}{مَدَنيَّـة}% Al Ahzab
\or \getHeader{#2}{#3}{سَبَأِ}{مَكيَّة}% Saba'
\or \getHeader{#2}{#3}{فَاطرٍ}{مَكيَّة}% Fatir
\or \getHeader{#2}{#3}{ي-س}{مَكيَّة}% Yaseen
\or \getHeader{#2}{#3}{الصَّافَّاتِ}{مَكيَّة}% As Saffat
\or \getHeader{#2}{#3}{ص-}{مَكيَّة}% Saad
\or \getHeader{#2}{#3}{الزُّمَر}{مَكيَّة}% Az Zumar
\or \getHeader{#2}{#3}{غَافِرٍ}{مَكيَّة}% Ghafir
\or \getHeader{#2}{#3}{فُصّلَت}{مَكيَّة}% Fussilat
\or \getHeader{#2}{#3}{الشُورى!}{مَكيَّة}% Ash Shurah
\or \getHeader{#2}{#3}{الزّخْرُفِ}{مَكيَّة}% Az Zukhruf
\or \getHeader{#2}{#3}{الدُخَانِ}{مَكيَّة}% Ad-Dukhan
\or \getHeader{#2}{#3}{الجَاثِيَة}{مَكيَّة}% Al-Jathiah
\or \getHeader{#2}{#3}{الأَحْقَافِ}{مَكيَّة}% Al-Ahqaf
\or \getHeader{#2}{#3}{مُحَمَّدٍ}{مَدَنيَّـة}% Muhammad
\or \getHeader{#2}{#3}{الفَتْحِ}{مَدَنيَّـة}% Alfat-h
\or \getHeader{#2}{#3}{الحُجُراتِ}{مَدَنيَّـة}% Al-Hujurat
\or \getHeader{#2}{#3}{ق-}{مَكيَّة}% Qaaf
\or \getHeader{#2}{#3}{الذّاريَاتِ}{مَكيَّة}% Ath-Thariyat
\or \getHeader{#2}{#3}{الطُّورِ}{مَكيَّة}% At-Tur
\or \getHeader{#2}{#3}{النَجمِ}{مَكيَّة}% An-Najm
\or \getHeader{#2}{#3}{القَمَرِ}{مَكيَّة}% Al Qamar 
\or \getHeader{#2}{#3}{الرَّحْم!نِ}{مَدَنيَّـة}% Ar-Rahman 
\or \getHeader{#2}{#3}{الوَاقِعَةِ}{مَكيَّة}% Al-Waqi'a 
\or \getHeader{#2}{#3}{الحـَدِيدِ}{مَدَنيَّـة}% Al-Hadeed 
\or \getHeader{#2}{#3}{المُجَـادلةِ}{مَدَنيَّـة}% Al-Mujadala 
\or \getHeader{#2}{#3}{الحَشْرِ}{مَدَنيَّـة}% Al-Hashr 
\or \getHeader{#2}{#3}{المُمْتَحنَةِ}{مَدَنيَّـة}% Al-Mumtahana 
\or \getHeader{#2}{#3}{الصَّفَّ}{مَدَنيَّـة}% As-Saff 
\or \getHeader{#2}{#3}{الجُمُعَةِ}{مَدَنيَّـة}% Al-Jumu'ah 
\or \getHeader{#2}{#3}{المنَافِقُونَ}{مَدَنيَّـة}% Al-Munafikoon 
\or \getHeader{#2}{#3}{التَغَابُنِ}{مَدَنيَّـة}% At-Taghabon 
\or \getHeader{#2}{#3}{الطَّلاَقِ}{مَدَنيَّـة}% At-Talaq 
\or \getHeader{#2}{#3}{التَّحرِيمِ}{مَدَنيَّـة}% At-Tahreem 
\or \getHeader{#2}{#3}{المُلكِ}{مَكيَّة}% Al-Mulk 
\or \getHeader{#2}{#3}{القَلَمِ}{مَكيَّة}% Al-Qalam 
\or \getHeader{#2}{#3}{الحَاقَّةِ}{مَكيَّة}% Al Haqqah 
\or \getHeader{#2}{#3}{المَعَارِجِ}{مَكيَّة}% Al-Ma'arij 
\or \getHeader{#2}{#3}{نُوحٍ}{مَكيَّة}% Nooh 
\or \getHeader{#2}{#3}{الجِنّ}{مَكيَّة}% Al-Jinn 
\or \getHeader{#2}{#3}{المُزَّمِّلِ}{مَكيَّة}% Al-Muzzammil 
\or \getHeader{#2}{#3}{المُدَّثَّرِ}{مَكيَّة}% Al-Muddaththir 
\or \getHeader{#2}{#3}{القِيامَةِ}{مَكيَّة}% Al-Qiyamah 
\or \getHeader{#2}{#3}{الأَنسَانِ}{مَدَنيَّـة}% Al-'Insan 
\or \getHeader{#2}{#3}{المُرسَلاَتِ}{مَكيَّة}% Al Mursalat 
\or \getHeader{#2}{#3}{النَّبأِ}{مَكيَّة}% An-Naba' 
\or \getHeader{#2}{#3}{النَّازِعَاتِ}{مَكيَّة}% An-Nazi'at 
\or \getHeader{#2}{#3}{عَبَسَ}{مَكيَّة}% 'Abasa
\or \getHeader{#2}{#3}{التَّكوِيرِ}{مَكيَّة}%al-takwiyr 
\or \getHeader{#2}{#3}{الانفِطَارِ}{مَكيَّة}%alA nfi.ta-ar 
\or \getHeader{#2}{#3}{المُطَفِّفِينَ}{مَكيَّة}% al-mu.taffifiyn
\or \getHeader{#2}{#3}{الانشِقَاقِ}{مَكيَّة}%alA n^siqa-aq 
\or \getHeader{#2}{#3}{البُروجِ}{مَكيَّة}% al-buruw^g
\or \getHeader{#2}{#3}{الطَّارِقِ}{مَكيَّة}%al-.t.ta-ariq 
\or \getHeader{#2}{#3}{الأَعلَى}{مَكيَّة}% alA `lay
\or \getHeader{#2}{#3}{الغَاشَيةِ}{مَكيَّة}% al-.ga-a^siyaT
\or \getHeader{#2}{#3}{الفَجرِ}{مَكيَّة}%al-fa^gr 
\or \getHeader{#2}{#3}{البَلدِ}{مَكيَّة}% al-balad
\or \getHeader{#2}{#3}{الشَمسِ}{مَكيَّة}% a^s-^sams
\or \getHeader{#2}{#3}{اللَيْلِ}{مَكيَّة}%al-layl 
\or \getHeader{#2}{#3}{الضّحَى!}{مَكيَّة}%a.d-.du.ha 
\or \getHeader{#2}{#3}{الشَرْحِ}{مَكيَّة}%alA n^sira-a.h 
\or \getHeader{#2}{#3}{التَّينِ}{مَكيَّة}% al-ttiyn
\or \getHeader{#2}{#3}{العَلَقِ}{مَكيَّة}%al-`alaq 
\or \getHeader{#2}{#3}{القَدْرِ}{مَكيَّة}% al-qadr
\or \getHeader{#2}{#3}{البَيّنَةِ}{مَدَنيَّـة}%al-bayyinaT 
\or \getHeader{#2}{#3}{الزَّلزَلةِ}{مَدَنيَّـة}% al-zalzalaT
\or \getHeader{#2}{#3}{العَاديَاتِ}{مَكيَّة}%al-`a-adiya-aT 
\or \getHeader{#2}{#3}{القَارَعَةِ}{مَكيَّة}%al-qa-ari`aT 
\or \getHeader{#2}{#3}{التَّكَاثُرِ}{مَكيَّة}% al-taka-a_tur
\or \getHeader{#2}{#3}{العَصْرِ}{مَكيَّة}% al-`a.sr
\or \getHeader{#2}{#3}{الهُمَزَةِ}{مَكيَّة}% al-humazaT
\or \getHeader{#2}{#3}{الفِيلِ}{مَكيَّة}%al-fiYl 
\or \getHeader{#2}{#3}{قُرَيْشٍ}{مَكيَّة}% quray^s
\or \getHeader{#2}{#3}{المَاعُونِ}{مَكيَّة}% al-ma-a`uwn
\or \getHeader{#2}{#3}{الكَوثَرِ}{مَكيَّة}% alkaw_tar
\or \getHeader{#2}{#3}{الكَافِرونَ}{مَكيَّة}% al-kafiruwn
\or \getHeader{#2}{#3}{النَّصرِ}{مَدَنيَّـة}% al-nna.sar
\or \getHeader{#2}{#3}{المَسَدِ}{مَكيَّة}%al-mas'ad 
\or \getHeader{#2}{#3}{الإِخلاَصِ}{مَكيَّة}% alA _hla-a.s
\or \getHeader{#2}{#3}{الفَلَقِ}{مَكيَّة}% al-falaq
\or \getHeader{#2}{#3}{النَّاسِ}{مَكيَّة}% an-na-as
\fi% end of ifcase
%
\begin{RLtext}%
\ayatrue
\transfalse% this command can be activated
%\fullvocalize% this command can be removed
}% end of \sura command

%\newcommand{\ayat}{%
%\LR{%
%\ifnum\ayatNo=0%
%\PackageError{noSura}{Please input sura first.}%
%{use Sura}%
%\else%
%\fi%
%\ifnum\ayatCount=\ayatNo%
%\PackageError{ayatExceeded}{The number of ayat more than = \the\ayatNo \ for sura = \the\suraNo. Pls correct it.}%
%{use less ayat}%
%\else%
%\fi% end of ifnum
%\temp=\ayatCount%
%\advance \temp by 1%
%\global\ayatCount=\temp%
%}%
%(\the\ayatCount)%
%\transfalse% this command can be activated
%}%

%command for error checking for the last sura.
\newcommand{\suraEnd}{%
\LR{%
\ifnum\value{ayac}=\ayatNo%
\else%
\newline%
\PackageError{incorrectAyatNo}{The number of ayat you provide = \the\value{ayac} \ for sura = \the\suraNo.%
The number of ayat should be = \the\ayatNo .Pls correct it.}%
{use less or more ayat}%
\fi% end of ifnum
}}%


\allowarab{\suraEnd}%
\allowarab{\sura}%
%\allowarab{\ayat}%















%\renewcommand{\headrulewidth}{4pt}
%\newlength{\offsetvframe}
%\setlength{\offsetvframe}{8pt}
%
%\newlength{\newheight}
%\setlength{\newheight}{1.03\textheight}
%
%\newlength{\newshift}
%\setlength{\newshift}{.55\columnwidth}
%
%\newlength{\rshift}
%\setlength{\rshift}{.85\columnwidth}
%
%\renewcommand{\headrulewidth}{0pt}
%\renewcommand{\footrulewidth}{0pt}
%
%	\newcommand\qframe{\setlength{\fboxrule}{2mm}% h1 et l1
 %   \setlength{\fboxsep}{0cm}%
  %  \leavevmode\hbox to0cm{\hspace*{-\newshift}\vbox to0cm{% l2
   %    \vspace*{\offsetvframe}\framebox{%
    %     \vrule width1.07\columnwidth height0cm depth0cm % l3
     %    \vrule width0cm height0cm depth\newheight % h3
      %}\vss}\hss}}
    %\fancyfoot{}
%
%\chead{\qframe}
